﻿param([Parameter(Mandatory=$true)][string]$server, [Parameter(Mandatory=$true)][string]$database, 
      [Parameter(Mandatory=$true)][string]$trusted,[string]$user,[string]$password, [Parameter(Mandatory=$true)][string]$query,
	  [Parameter(Mandatory=$true)][string]$expOut)

$erroractionpreference = 'stop';
trap [exception]{
	$outf = $MyInvocation.MyCommand.Definition + ".out";
	$_.Exception.Message > $outf
}

$outf = $MyInvocation.MyCommand.Definition + ".out";
$MyInvocation.Line > ($MyInvocation.MyCommand.Definition + ".debug_cmd")

[System.Data.SqlClient.SqlConnection] $cnn = new-object System.Data.SqlClient.SqlConnection;
$cnn.ConnectionString = "Data Source=" + $server + ";Database=" + $database;
if ($trusted.ToUpper() -eq  "TRUE"){ $cnn.ConnectionString += "Integrated Security=True";  }
else { $cnn.ConnectionString += ";User Id=" + $user + ";Password=" + $password; }     
$cnn.ConnectionString += "; Timeout=60;";

try{
	$cnn.Open();
	[System.Data.SqlClient.SqlCommand] $sqlCmd = new-object System.Data.SqlClient.SqlCommand($query, $cnn);
	$r = $sqlCmd.ExecuteScalar();
	if($r -eq $null){
		throw "The expected output is null or emtpy";
	} else {
		if($r.ToString() -ne $expOut){
			throw "The expected output ($r) does not match with ($expOut)";
		}
	}
}finally{
	if($cnn.State -eq [System.Data.ConnectionState]::Open){
		$cnn.Close();
	}
}