#!/bin/bash
#
#	CheckMySQL.sh						
#	Usage: ChkMySQL.sh [server] [user] [password] [sqlquery1;sql2]
#																	

log="$0.out"
echo "Command: ./$0 $*" > $log
echo "Params: $#" >> $log

# Checking arguments
declare -i idx=2
for arg in "$@"
do
	next=${!idx}
	first=${next:0:1}
	if [ "$arg" == "-server" -a "$first" != "-" ]; then 
		server=$next
	fi
	if [ "$arg" == "-user" -a "$first" != "-" ]; then 
		user=$next
	fi
	if [ "$arg" == "-password" -a "$first" != "-" ]; then 
		password=$next
	fi
	if [ "$arg" == "-query" -a "$first" != "-" ]; then 
		query=$next
	fi
	idx=$idx+1
done

echo "" >> $log
echo "Server: $server" >> $log
echo "User: $user" >> $log
echo "Query: $query" >> $log
echo "" >> $log

echo "-------------" >> $log
mysql -u $user -p$password -h $server -e "$query" &>> $log
retcode=$?

echo "-------------" >> $log

echo "" >> $log
echo "ExitCode: $retcode" >> $log
exit $retcode
