#!/bin/bash
#
#	Usage: ./$0.sh [server] [user] [password] [sqlquery1;sql2]
#																	

. $HOME/.bashrc
log="$0.out"
echo "Command: ./$0 $*" > $log
echo "Params: $#" >> $log

# Checking arguments

declare -i idx=2
for arg in "$@"
do
	next=${!idx}
	first=${next:0:1}
	if [ "$arg" == "-server" -a "$first" != "-" ]; then 
		server=$next
	fi
	if [ "$arg" == "-sid" -a "$first" != "-" ]; then 
		sid=$next
	fi
	if [ "$arg" == "-user" -a "$first" != "-" ]; then 
		user=$next
	fi
	if [ "$arg" == "-password" -a "$first" != "-" ]; then 
		pwd=$next
	fi
	if [ "$arg" == "-query" -a "$first" != "-" ]; then 
		query=$next
	fi
	idx=$idx+1
done

echo "" >> $log
echo "Server: $server" >> $log
echo "SID: $sid" >> $log
echo "User: $user" >> $log
echo "Query: $query" >> $log
echo "" >> $log

echo "-------------" >> $log
#echo $query|sqlplus -s $user/$pwd@$sid > sqlplus.out
sqlplus $user/$pwd << EOF &> sqlplus.out
WHENEVER SQLERROR EXIT FAILURE;
WHENEVER OSERROR EXIT FAILURE;
$query
EOF

retcode=$?
cat sqlplus.out >> $log

out=`cat sqlplus.out|wc -l`
if [ $out -eq 0 ] ; then
        retcode=1
fi

out=`cat sqlplus.out|grep SP2-|wc -l`
grep SP2- sqlplus.out
if [ $? -eq 0 ] ; then
        retcode=1
fi

grep ORA- sqlplus.out
if [ $? -eq 0 ] ; then
        retcode=1
fi

grep "no rows selected" sqlplus.out
if [ $? -eq 0 ] ; then
        retcode=1
fi



echo "-------------" >> $log

echo "" >> $log
echo "ExitCode: $retcode" >> $log
exit $retcode

