﻿param([Parameter(Mandatory=$true)][string]$url,[Parameter(Mandatory=$true)][string]$expWord)

$erroractionpreference = 'stop';
trap [exception]{
	$outf = $MyInvocation.MyCommand.Definition + ".out";
	$_.Exception.Message > $outf
}

[System.Net.WebRequest] $request;
[System.Net.WebResponse] $response;

try
{
    $request = [System.Net.WebRequest]::Create($url);
    $response = $request.GetResponse(); 
}
catch
{
    throw "ERROR: $_.Exception.Message";
}

$reader = new-object System.IO.StreamReader($response.GetResponseStream());
$html = $reader.ReadToEnd();

$reader.Close();
$response.Close();

foreach ($w in $expWord.Split(','))
{
    $word = $w.Trim();
    if ($html.Contains($word) -eq $false)
    {
        throw "Error: URL response does not contain $word";
    }
}