﻿param([Parameter(Mandatory=$false)][string]$folder)

function Expand-ZIPFile($file, $destination)
{
        $shell = new-object -com shell.application

                if(!$file.ToLower().StartsWith("c:\")) {
                        $file = "C:" + $file
                }

                if(!$destination.ToLower().StartsWith("c:\")) {
                        $destination = "C:" + $destination
                }

        $zip = $shell.NameSpace($file)
        foreach($item in $zip.items())
        {
                $shell.Namespace($destination).copyhere($item,0x14)
        }
}

$erroractionpreference = 'stop';
$outf = $MyInvocation.MyCommand.Path + ".out";
$scriptpath = Split-Path $MyInvocation.MyCommand.Path -Parent
$clamscan = $scriptpath + "\clamav\clamscan.exe"
$clamzip = $scriptpath + "\clamav_scan.zip"
$vcredist = $scriptpath + "\vcredist_x64.exe"

trap [exception]{
        $_.Exception.Message > $outf
		Sleep 2
}

if((Test-Path $folder) -eq $false) { throw $folder + " is not a valid path in the guestos" }

Remove-Item -Force $outf -ErrorAction SilentlyContinue
Expand-ZIPfile $clamzip $scriptpath

Start-Process -Wait -FilePath $vcredist -ArgumentList /q
Sleep 2

$proc = Start-Process -PassThru -FilePath $clamscan -ArgumentList "-o -r $folder -l $outf"
Wait-Process -InputObject $proc
$exit = $proc.ExitCode
Sleep 2

$infected = Get-Content $outf | Select-String -Pattern "Infected files:"
$content = Get-Content $outf
$infected > $outf
$content >> $outf
if($exit -ne 0)
{
        throw (Get-Content $outf)
}
