$erroractionpreference = 'stop';
$outf = $MyInvocation.MyCommand.Definition + ".out";
trap [exception]{
	$_.Exception.Message > $outf
}

$nics = [System.Net.NetworkInformation.NetworkInterface]::GetAllNetworkInterfaces();
foreach ($nic in $nics) {
   $prop = $nic.GetIPProperties();
   if (($nic.OperationalStatus -eq [System.Net.NetworkInformation.OperationalStatus]::Up)  -and 
       ($nic.NetworkInterfaceType -eq [System.Net.NetworkInformation.NetworkInterfaceType]::Ethernet -or $nic.NetworkInterfaceType -eq [System.Net.NetworkInformation.NetworkInterfaceType]::GigabitEthernet -or $nic.NetworkInterfaceType -eq [System.Net.NetworkInformation.NetworkInterfaceType]::Ethernet -or $nic.NetworkInterfaceType -eq [System.Net.NetworkInformation.NetworkInterfaceType]::Ethernet3Megabit -or $nic.NetworkInterfaceType -eq [System.Net.NetworkInformation.NetworkInterfaceType]::FastEthernetFx -or $nic.NetworkInterfaceType -eq [System.Net.NetworkInformation.NetworkInterfaceType]::FastEthernetT))
                    {
                        [string]$ga = "";
                        if ($prop.GatewayAddresses.Count -gt 0) { $ga  = $prop.GatewayAddresses[0].Address};

                        [string]$dns1 = "";
                        if ($prop.DnsAddresses.Count -gt 0) { $dns1  = $prop.DnsAddresses[0]};

                        [string]$dns2 = "";
                        if ($prop.DnsAddresses.Count -gt 1) { $dns2  = $prop.DnsAddresses[1]};

                        [string]$ip = "";
                        [string]$mask = "";
                        foreach ($ua in $prop.UnicastAddresses){
                            if ($ua.Address.AddressFamily -eq [System.Net.Sockets.AddressFamily]::InterNetwork)
                                {
                                    $ip= $ua.Address;
                                    $mask=$ua.IPv4Mask;
                                    break;
                                }
                        }

                    $network = New-Object PSObject -Property @{
                        Adapter =  $nic.Name;
                        DHCP = $prop.GetIPv4Properties().IsDhcpEnabled;
                        GW = $ga;
                        DNS1 =$dns1;
                        DNS2 =$dns2;
                        IP =$ip;
                        Mask = $mask;
                    }
					$network  | add-member scriptmethod tostring { 'NAME={0}; IP={1}; MASK={2}; GW={3}; DNS1={4}; DNS2={5};' -f $this.Adapter, $this.IP, $this.Mask, $this.GW, $this.DNS1, $this.DNS2 } -force 
                    $network.ToString()
					$network.ToString() >> $outf
    }
   
}