SET search_path TO public;

CREATE OR REPLACE FUNCTION user_exists(usr_name VARCHAR)
RETURNS BOOLEAN AS
$BODY$BEGIN
-- search the pg_roles table to see if user exists
        RETURN (SELECT COUNT(*) FROM pg_roles WHERE
        lower(rolname)=lower(usr_name));
END$BODY$
LANGUAGE 'plpgsql' VOLATILE;

CREATE OR REPLACE FUNCTION create_users()
RETURNS INT4 AS
$BODY$DECLARE
        res INT4;
        -- usr array will hold user name and password
        -- initialize the array for every new user/password combination
        usr VARCHAR[][] := ARRAY [[NULL,NULL]];
BEGIN
        res := 0;
-- assign more array elements here to add users/logins
        usr[1][1] := 'rdr';
        usr[1][2] := 'vmware';

        FOR i IN 1..array_upper(usr,1) LOOP
                IF NOT user_exists(usr[i][1])
                THEN
                        RAISE NOTICE 'Creating % user', usr[i][1];
                        EXECUTE 'CREATE USER ' || quote_ident(usr[i][1]) || ' WITH PASSWORD ' || quote_literal(usr[i][2]) || ' LOGIN CREATEDB';
                END IF;
        END LOOP;
        RETURN res;
END;
$BODY$
LANGUAGE 'plpgsql' VOLATILE;

SELECT create_users();
DROP FUNCTION create_users();
DROP FUNCTION public.user_exists(usr_name VARCHAR);
